unit dm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   Db, grids, oledb, ActiveX, comobj, olectrls,ADODB_TLB;

type
  TCursorLocation = (ad_UseServer, ad_UseClient);

  TParameterDirection = (ad_ParamUnknown, ad_ParamInput, ad_ParamOutput, ad_ParamInputOutput,
                         ad_ParamReturnValue);

  TQuesInfo = Record
        subject:string;
        ID:String;
        from:string;
        RegdateTime:string;
        Points:String;
        Status:string;
        RoomName:string;
        GetTimes:String;
        ReplyTimes:String;
        Content:string;
        Parent:string;
        read_n:string;
        roomid:string;
        datetime:string;
  end;

  TRoomInfo = Record
        ID:string;
        Name:string;
        Master1,Master2:string;
        group:string;
        LetterNum:integer;
        NewLetter:integer;
  end;

  TDM1 = class(TDataModule)
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    { Private declarations }
    FQuesCount: integer;
    ADOConnection1:_Connection;
    DSLocal:_Recordset;
    DSQues:_Recordset;
    DSEdit:_Recordset;

    QlistPos:integer;
    ShowData:boolean;

    procedure DSLocalQuery(ssql:string);
    procedure DSEditQuery(ssql:string);
    procedure SaveConnStr(strConn:string);
    procedure ShowGrid;
    procedure SetGridCols;
    function LoadConnStr:string;
    procedure SetRoomLettersCount(Roomid,Letterscount:integer);
    procedure IncRoomLettersCount(Roomid:integer);
  public
    { Public declarations }
    sltRooms:TStringList;
    SltGroups:TStringList;
    ConnStrFile:string;
    sgQList:TStringGrid;
    procedure OnDrawSGCell(Sender: TObject; ACol, ARow: Longint; Rect: TRect; State: TGridDrawState);

    function GetRoomName(index:integer):string;
    function SetConnnection:boolean;
    function PromptDataSource(ParentHandle: THandle; InitialString: WideString): WideString;

    procedure InitDB(InitCtr:string);
    procedure GetRoomRecord(RoomIndex:integer);
    function GetRoomRecordsCount(RoomIndex:integer):integer;
    procedure GetQuesContent(ID:integer;var QuesInfo: TQuesInfo);
    procedure Search(strSearch:string);
    procedure GetRoomsByGroup(Rooms:TStringlist;GroupName:string);
    procedure SelectNoRoom;

    function UpdateRoomList(RoomInfo:TRoomInfo):boolean;
    function UpdateLetter(LetterInfo:TQuesInfo):boolean;
    function GetDayLastTime(Date:TDateTime = 0):TDateTime;
    function CalcuRoomRecords(RoomIndex:integer):integer;
    function ConfigConnstr:string;

    property QuesCount:integer read FQuesCount;
    procedure EmptyRooms;
    procedure CalcuAllRoomsRecords;

  end;

var
  DM1: TDM1;
  EmptyParam: OleVariant;

const

//  GroupFieldName = 'grou_';
  GroupFieldName = 'group';
  CursorLocationValues: array[TCursorLocation] of TOleEnum = (adUseServer, adUseClient);

implementation

uses htmlGen;

{$R *.DFM}

{ TDM1 }


procedure TDM1.DataModuleCreate(Sender: TObject);
begin
        TVarData(EmptyParam).VType := varError;
        TVarData(EmptyParam).VError := $80020004;

        sltRooms := TStringList.Create;
        SltGroups := TStringList.Create;
        ConnStrFile := getCurPath + 'strconn.txt';
        ShowData := false;

        ADOConnection1 := CreateOleObject('ADODB.Connection') as _Connection;
        DSLocal := CreateOleObject('ADODB.Recordset') as _Recordset;
        DSQues := CreateOleObject('ADODB.Recordset') as _Recordset;
        DSLocal.CursorType := CursorLocationValues[ad_UseServer];
        DSEdit := CreateOleObject('ADODB.Recordset') as _Recordset;
end;


procedure TDM1.DataModuleDestroy(Sender: TObject);
begin
        ADOConnection1.Close;
        sltRooms.free;
        SltGroups.free;
end;

procedure TDM1.DSLocalQuery(ssql: string);
var
        Source: OleVariant;
begin
//        ShowMessage(ssql);
        with DSLocal do
        begin
                if state <> AdStateClosed then close;
                Source := ssql;
//                Open(Source,ADOConnection1, AdOpenForwardOnly, AdLockReadOnly,adCmdText);
                Open(Source,ADOConnection1, AdOpenForwardOnly, AdLockReadOnly,adCmdText);
        end;

end;


procedure TDM1.GetQuesContent(ID:integer;var QuesInfo: TQuesInfo);
var
        ssql:string;
        htmltmp:ThtmlView;
        Source:OleVariant;
begin
     ssql:='select * from letters where ( id = ' + inttostr(ID) + ' ) or ( parent = ' + inttostr(ID) + ' ) order by regdatetime';
{     ssql:='select * from letters where ( id = ' + inttostr(ID) + ') ';}
//     ssql:='select * from letters where ( id = ' + inttostr(ID) + ' ) order by regdatetime';

     with DSQues do
     begin
        if state <> AdStateClosed then close;
        Source := ssql;
        Open(Source,ADOConnection1, AdOpenForwardOnly, AdLockReadOnly,adCmdText);
     end;

     with QuesInfo,DSQues do
     begin
        //Ϊnullֶ,ܳ
        if not VarIsNull(Fields['subject'].value) then subject := Fields['subject'].value;
        ID := Fields['ID'].value;
        from := Fields['Userfrom'].value;
        RegdateTime := Fields['RegDateTime'].value;
        datetime := Fields['DateTime'].value;
        Points := Fields['Points'].value;
        if not VarIsNull(Fields['Roomid'].value) then RoomName := GetRoomName(fields['Roomid'].value);
        GetTimes := Fields['GetTimes'].value;
        if not VarIsNull(Fields['ReplyTimes'].value) then ReplyTimes := Fields['ReplyTimes'].value;
         case integer(Fields['Status'].value) of
         0: QuesInfo.Status := '';
         1: QuesInfo.Status := '';
         2: QuesInfo.Status := 'Ѵ';
         else QuesInfo.Status := '';
         end;
     end;

     htmltmp := thtmlview.create;
     with htmltmp do
     begin
         writeHeader(QuesInfo.subject);
         addinfo(QuesInfo.subject,'',QuesInfo.Points);
         addQues(QuesInfo.ID, QuesInfo.from, DSQues.fields['content'].value, QuesInfo.RegdateTime);
     end;

     DSQues.MoveNext;

     with DSQues do
     while not Eof do
     begin
       htmltmp.add(fields['id'].value,fields['UserFrom'].value,fields['content'].value,formatdatetime('yyyy-mm-dd hh:nn:ss',fields['datetime'].value));
       MoveNext;
     end;

     DSQues.Close;
     QuesInfo.Content := htmltmp.GetContent;    

end;

procedure TDM1.GetRoomRecord(RoomIndex: integer);
var
   ssql:string;
   i,lettercount:integer;
begin
     FQuesCount := GetRoomRecordsCount(RoomIndex);

//     FQuesCount := 100;

     ssql:='select id,subject,userfrom,points,datetime,replytimes,status from letters where parent = 0';
     if RoomIndex <> -1 then
     begin
       ssql:= ssql + ' and roomid = ' + IntToStr(RoomIndex);
     end;

     //ȥעͣõļ¼µɵĽ
     ssql := ssql + ' order by DateTime DESC';

     DSLocalQuery(ssql);

     ShowGrid;
end;

function TDM1.GetRoomName(index: integer): string;
begin
        Result := sltRooms.Values[inttostr(index)];
end;

procedure TDM1.InitDB(InitCtr:string);
var
    FileName:string;
    strConn:string;
begin
       filename := GetCurpath + 'delphibbs.mdb';

//       if InitCtr = '' then strConn := LoadConnStr else strConn := InitCtr;
       strConn := InitCtr;
      if strConn = '' then
      begin
        if FileExists(filename) then 
              strConn := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + GetCurpath +'delphibbs.mdb;Persist Security Info=False'
        else
        begin
              ShowMessage('ûҵ' + filename + '!');
              exit;  
        end;
                              
      end;

      with ADOConnection1 do
      begin
              if state <> AdStateClosed  then Close;
              if strConn <> '' then Open(strConn,'','',adConnectUnspecified);
      end;

//      DSLocalQuery('select id,room,[group] from rooms');
      DSLocalQuery('select id,room,[' + GroupFieldName + '] from rooms');
      sltRooms.Clear;

      while not DSLocal.Eof do
      begin
//              sltRooms.Add(DSLocal.fields['id'].value + '=' + DSLocal.fields['Group'].value  + ' ' + DSLocal.fields['room'].value);
//              sltRooms.Add(string(DSLocal.fields['id'].value) + '=');
              sltRooms.Add(string(DSLocal.fields['id'].value) + '=' + string(DSLocal.fields[GroupFieldName].value)  + ' ' + string(DSLocal.fields['room'].value));
              DSLocal.MoveNext;
      end;
      DSLocal.Close;

      DSLocalQuery('select distinct [' + GroupFieldName + '] from rooms ');
      SltGroups.Clear;
      while not DSLocal.Eof do
      begin
              SltGroups.Add(string(DSLocal.fields[0].value));
              DSLocal.MoveNext;
      end;
      DSLocal.Close;
//      ShowMessage(SltGroups.Text); 


end;

function TDM1.SetConnnection:boolean;
var
        stronn:string;
begin
        Result := false ;
        stronn := PromptDataSource(Application.Handle,ADOConnection1.ConnectionString);
        if stronn <> ADOConnection1.ConnectionString then
        begin
               SaveConnStr(stronn);
               try
                        InitDB(stronn);
               except
                        ShowMessage('ʼݿʱ ');
                        exit;
               end;

               Result := true;
        end;
end;

procedure TDM1.Search(strSearch: string);
var
        ssql:string;
begin
        ssql:='select count(*) from letters ' + strSearch;
        DSLocalQuery(ssql);

        FQuesCount := DSLocal.Fields[0].value;
        DSLocal.Close;

        ssql:='select id,subject,userfrom,points,datetime,replytimes,status from letters ' + strSearch + ' order by datetime desc ';
        DSLocalQuery(ssql);

        ShowGrid;
end;

function TDM1.UpdateRoomList(RoomInfo:TRoomInfo): boolean;
var
        ssql:string;
begin
   Result := false;

    with RoomInfo do
    begin
            ssql := 'INSERT INTO ROOMS (ID, ROOM, [' + GroupFieldName + '], master, master2) VALUES('
            + ID + ', ''' + Name + ' '', ''' + group + ' '', ''' + Master1 + ' '', ''' + Master2 + ' '')';
            ADOConnection1.Execute(ssql,EmptyParam,adCmdText + adExecuteNoRecords);
    end;

end;

function TDM1.UpdateLetter(LetterInfo:TQuesInfo): boolean;
var
        ssql:string;
        Source:OleVariant;
begin
        Result := false;

        ssql := 'select * from letters where id = ' + LetterInfo.ID;
        Source := ssql;
        DSEdit.Open(Source,ADOConnection1, AdOpenKeyset, AdLockOptimistic,adCmdText);

        if DSEdit.Eof then
        begin
                DSEdit.AddNew(EmptyParam,EmptyParam);
        end
        else
        begin
//                DSEdit.Edit;
        end;

//        ShowMessage(LetterInfo.ID);

        with DSEdit, LetterInfo do
        begin
                fields['ID'].value := ID;
                fields['RegDateTime'].value := StrToDateTime(RegdateTime);
                fields['DateTime'].value := StrToDateTime(DateTime);
                fields['UserFrom'].value := from;
                fields['Subject'].value := subject;
                fields['RoomID'].value := roomid;
                fields['Content'].value := Content;
                fields['Expert'].value := ' ';
                fields['Points'].value := Points;
                fields['Parent'].value := Parent;
                fields['Status'].value := Status;
                fields['NeedEMail'].value := 0;
                fields['IPAddr'].value := 127;
                fields['GetTimes'].value := read_n;
                fields['ReplyTimes'].value := ReplyTimes;
                Update(EmptyParam,EmptyParam);
                close;
        end;

        IncRoomLettersCount(strtoint(LetterInfo.roomid));       //бӼ1     
end;

procedure TDM1.EmptyRooms;
var
        ssql:string;
begin
   ssql := 'delete from rooms';
   ADOConnection1.Execute(ssql,EmptyParam,adCmdText + adExecuteNoRecords);
//   ExecSql(ssql);

end;

function TDM1.GetDayLastTime(Date: TDateTime = 0): TDateTime;
var
        ssql:string;
        tmpVar:OleVariant;
        AdoComm:_Command;
        Parameter:_Parameter;
const
  ValidDirectionValues: array[TParameterDirection] of TOleEnum =
    (adParamInput, adParamInput, adParamOutput, adParamInputOutput,
     adParamReturnValue);
begin
{Ϊ0ʱָһӵʱ䣬
򣬷м¼һӵʱ}
        if Date = 0 then
          ssql := 'select max(datetime) from letters'
        else
        begin
          Date := trunc(Date);
//          ssql := 'select max(datetime) from letters where datetime > :datetime1 and datetime < :datetime2';
          ssql := 'select max(datetime) from letters where datetime > ? and datetime < ?';
        end;
//        ShowMessage(ssql);

        AdoComm := CreateOleObject('ADODB.Command') as _Command;
        AdoComm.Set_ActiveConnection(ADOConnection1);
        AdoComm.CommandText := ssql;
        AdoComm.CommandType := AdCmdText;

        Parameter := AdoComm.CreateParameter('datetime1',adDate,ValidDirectionValues[ad_ParamInput],510,Date);
        AdoComm.Parameters.Append(Parameter);
        Parameter := AdoComm.CreateParameter('datetime2',adDate,ValidDirectionValues[ad_ParamInput],510,Date + 1);
        AdoComm.Parameters.Append(Parameter);
        DSEdit := AdoComm.Execute(tmpVar,EmptyParam,0);

        if not VarIsNull(DSEdit.Fields[0].value) then   //ҵĽΪ0
        begin
          Result := DSEdit.Fields[0].value;
//          ShowMessage(DateTimeToStr(DSEdit.Fields[0].value));
        end
        else
        begin
          Result := Date;
        end;
        DSEdit.Close;
end;


procedure TDM1.GetRoomsByGroup(Rooms: TStringlist; GroupName: string);
begin
        DSLocalQuery('select id,room from rooms where [' + GroupFieldName + '] = ''' + GroupName + ''' order by id');

        Rooms.Clear;
        while not DSLocal.Eof do
        begin
                Rooms.Add(string(DSLocal.fields['room'].value)  + '=' + string(DSLocal.fields['id'].value));
                DSLocal.MoveNext;
        end;
        DSLocal.Close;

end;

procedure TDM1.SelectNoRoom;
begin
//        if DSLocal.Active = true then DSLocal.Close;
        ShowData := false;
end;


procedure TDM1.SaveConnStr(strConn: string);
var
        sltConn:TStringlist;
begin
       sltConn := TStringList.Create;
       sltConn.Text := strConn;
       sltConn.SaveToFile(ConnStrFile);
       sltConn.free;

end;

function TDM1.LoadConnStr: string;
var
        sltConn:TStringlist;
begin
       sltConn := TStringList.Create;
       if FileExists(ConnStrFile) then
         sltConn.LoadFromFile(ConnStrFile)
       else
         sltConn.Text := '';
       
       Result := sltConn.Text;
       sltConn.free;

end;


procedure TDM1.DSEditQuery(ssql: string);
var
        Source: OleVariant;
begin
        with DSEdit do
        begin
                if state <> AdStateClosed then close;
                Source := ssql;
                Open(Source,ADOConnection1, AdOpenForwardOnly, AdLockReadOnly,adCmdText);
        end;

end;

procedure TDM1.ShowGrid;
var
        i:integer;
begin
     QlistPos := 0;
     if DSLocal.EOF then     //ҵļ¼Ϊ0
     begin
        //
        with sgQList do
        begin
            RowCount := 2;
            FixedRows := 1;
            Cells[0,1] := '';
            Cells[1,1] := '';
            Cells[2,1] := '';
            Cells[3,1] := '';
            Cells[4,1] := '';
            Cells[5,1] := '';
            Cells[6,1] := '';
        end;
     end
     else
     sgQList.RowCount := FQuesCount + 1;

     sgQList.TopRow := 1;
     SetGridCols;

     ShowData := true;
     sgQList.Refresh;

end;


procedure TDM1.OnDrawSGCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
        LastRow,Flag,i:integer;
        strtmp:string;
begin
        if ShowData = false then exit;
        if ACol <> 0 then exit;
        if DSLocal.State <> AdStateOpen then exit;
        with sgQList do
        begin
                LastRow := TopRow + VisibleRowCount;
                if LastRow > RowCount then LastRow := RowCount ;
//                ShowMessage(IntToStr(LastRow));
        end;

        Flag := LastRow - QlistPos;
        for i := 0 to Flag - 1 do
        with sgQList do
        begin
                if DSLocal.EOF then break;
                inc(QlistPos);
                Cells[0,QlistPos] := DSLocal.Fields['id'].value;
                Cells[1,QlistPos] := DSLocal.Fields['subject'].value;
                Cells[2,QlistPos] := DSLocal.Fields['userfrom'].value;
                Cells[3,QlistPos] := DSLocal.Fields['points'].value;
                Cells[4,QlistPos] := DSLocal.Fields['datetime'].value;
                Cells[5,QlistPos] := DSLocal.Fields['replytimes'].value;
                case integer(DSLocal.Fields['status'].value) of
                  0: strtmp:= '';
                  1: strtmp:= '';
                  2: strtmp:= 'Ѵ';
                  else strtmp := '';
                end;
                Cells[6,QlistPos] := strtmp;
                DSLocal.MoveNext;   
        end;

end;

function TDM1.PromptDataSource(ParentHandle: THandle;InitialString: WideString): WideString;
var
  DataInit: IDataInitialize;
  DBPrompt: IDBPromptInitialize;
  DataSource: IUnknown;
  InitStr: PWideChar;
begin
  Result := InitialString;
  DataInit := CreateComObject(CLSID_DataLinks) as IDataInitialize;
  if InitialString <> '' then
    DataInit.GetDataSource(nil, CLSCTX_INPROC_SERVER,
      PWideChar(InitialString), IUnknown, DataSource);
  DBPrompt := CreateComObject(CLSID_DataLinks) as IDBPromptInitialize;
  if Succeeded(DBPrompt.PromptDataSource(nil, ParentHandle,
    DBPROMPTOPTIONS_PROPERTYSHEET, 0, nil, nil, IUnknown, DataSource)) then
  begin
    InitStr := nil;
    DataInit.GetInitializationString(DataSource, True, InitStr);
    Result := InitStr;
  end;
end;

procedure TDM1.SetGridCols;
begin
        with sgQList do
        begin
                ColWidths[0] := 50;
                ColWidths[1] := 350;
                ColWidths[2] := 70;
                ColWidths[3] := 30;
                ColWidths[4] := 115;
                ColWidths[5] := 50;
                ColWidths[6] := 50;

                Cells[0,0] := '';
                Cells[1,0] := '';
                Cells[2,0] := '';
                Cells[3,0] := '';
                Cells[4,0] := 'ظʱ';
                Cells[5,0] := 'ظ';
                Cells[6,0] := '״̬';

        end;

end;

function TDM1.GetRoomRecordsCount(RoomIndex: integer):integer;
var
   ssql:string;
   i,lettercount:integer;
begin
     lettercount := 0;
     
     //roomsѰlettercount   
     if RoomIndex <> -1 then
     begin
         ssql:='select letternum from rooms where id = ' + inttostr(RoomIndex);

         DSLocalQuery(ssql);
         if VarIsNull(DSLocal.Fields[0].value) then
           lettercount := 0
         else
           lettercount := DSLocal.Fields[0].value;
         DSLocal.Close;
     end;

     //Ҳͽͳ
     if lettercount = 0 then
     begin
         lettercount := CalcuRoomRecords(RoomIndex);

         if RoomIndex <> -1 then
         begin
           SetRoomLettersCount(RoomIndex,lettercount);
         end;                        

     end; 
     Result := lettercount;   
end;

procedure TDM1.SetRoomLettersCount(Roomid, Letterscount: integer);
var
        ssql:string;
        source:OleVariant;
begin
//roomslettercountֶ
   ssql := 'select * from rooms where id = ' + inttostr(Roomid);
   source := ssql;
   DSLocal.Open(Source,ADOConnection1, AdOpenForwardOnly, AdLockOptimistic,adCmdText);

   with DSLocal do
   begin
      if not Eof then
      begin
                fields['Letternum'].value := Letterscount;
                Update(EmptyParam,EmptyParam);
      end;
      Close;
   end;
end;

procedure TDM1.IncRoomLettersCount(Roomid: integer);
var
        ssql:string;
        source:OleVariant;
begin
//roomslettercountֶ
   ssql := 'select * from rooms where id = ' + inttostr(Roomid);
   source := ssql;
   DSEdit.Open(Source,ADOConnection1, AdOpenForwardOnly, AdLockOptimistic,adCmdText);

   with DSEdit do
   begin
      if not Eof then
      begin
                if not VarIsNull(fields['Letternum'].value) then
                begin
                        fields['Letternum'].value := integer(fields['Letternum'].value) + 1;
                        Update(EmptyParam,EmptyParam);
                end;
      end;
      Close;
   end;
end;

function TDM1.CalcuRoomRecords(RoomIndex:integer):integer;
var
        i,lettercount:integer;
        ssql:string;
begin
         ssql:='select count(*) from letters where parent = 0';
         if RoomIndex <> -1 then
         begin
           ssql:= ssql + ' and roomid = ' + IntToStr(RoomIndex);
         end;

         DSLocalQuery(ssql);
         lettercount := DSLocal.Fields[0].value;
         DSLocal.Close;

         Result := lettercount;
end;

procedure TDM1.CalcuAllRoomsRecords;
var
        i,Roomid:integer;
begin
        for i := 0 to sltRooms.Count - 1 do
        begin
                Roomid := strtoint(sltRooms.Names[i]);
                SetRoomLettersCount(Roomid,GetRoomRecordsCount(Roomid));
        end;

end;

function TDM1.ConfigConnstr: string;
begin
        Result := PromptDataSource(Application.Handle,ADOConnection1.ConnectionString);
end;

end.
