unit update;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,xml,dm, ExtCtrls;

type
  TfrmUpdata = class(TForm)
    btnDoList: TButton;
    btnClose: TButton;
    lblStatus2: TLabel;
    ProgressBar: TProgressBar;
    btnAbort: TButton;
    btnUpLetters: TButton;
    lblStatus1: TLabel;
    rgTimePeriod: TRadioGroup;
    DTPFrom: TDateTimePicker;
    sbStatus: TStatusBar;
    chkForce: TCheckBox;
    procedure btnCloseClick(Sender: TObject);
    procedure btnDoListClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnUpLettersClick(Sender: TObject);
    procedure btnAbortClick(Sender: TObject);
    procedure CreateParams(VAR Params: TCreateParams);Override;

    procedure OnXMLProcess;
    procedure OnStatusChange;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Private declarations }
    XMLData:TXMLData;
    procedure GetQlist;
    procedure UpdateLetters;
  public
    { Public declarations }
  end;

var
  frmUpdata: TfrmUpdata;

implementation

{$R *.DFM}

procedure TfrmUpdata.btnCloseClick(Sender: TObject);
begin
        Close;
end;

procedure TfrmUpdata.btnDoListClick(Sender: TObject);
begin
        lblStatus1.Caption := 'ȡбϢ';
        Refresh;
        XMLData.GetRoomList;
        lblStatus1.Caption := 'ڸ±طб';
        XMLData.UpdateRoomList;
        lblStatus1.Caption := 'ɡ';
        lblStatus2.Caption := XMLData.GetLastError;
end;

procedure TfrmUpdata.FormCreate(Sender: TObject);
begin
        XMLData := TXMLData.Create;
        XMLData.OnUpdateLetter := OnXMLProcess;
        XMLData.OnStatusChange := OnStatusChange;
end;

procedure TfrmUpdata.FormDestroy(Sender: TObject);
begin
        XMLData.free;
        frmUpdata := nil;
end;

procedure TfrmUpdata.GetQlist;
begin
{        lblStatus2.Caption := 'ȡбϢ';
        Refresh;
        XMLData.GetQList;
        lblStatus2.Caption := XMLData.GetLastError;}

end;

procedure TfrmUpdata.btnUpLettersClick(Sender: TObject);
begin
        UpdateLetters;
end;

procedure TfrmUpdata.UpdateLetters;
begin
        lblStatus1.Caption := ''; 
        lblStatus2.Caption := '';
        ProgressBar.Position := 0;
        sbStatus.Panels[1].Text := '';
        sbStatus.Panels[2].Text := '';
        XMLData.UpdateLettersAll(DTPFrom.DateTime,rgTimePeriod.ItemIndex, chkForce.Checked);
        lblStatus1.Caption := 'ɡ';
        lblStatus2.Caption := XMLData.GetLastError;
        sbStatus.Panels[2].Text := 'ʱ' + formatdatetime('hh:nn:ss:zz',XMLData.ElapseTime) + '' + inttostr(XMLData.FetchLetter) + '';
end;

procedure TfrmUpdata.btnAbortClick(Sender: TObject);
begin
        XMLData.AbortFlag := true;
end;

procedure TfrmUpdata.OnXMLProcess;
begin
        with XMLData do
        begin
                ProgressBar.Position := (CurLetter+1) * 100 div LettersCount;
                lblStatus1.Caption := '' + inttostr(DaysCount) + 'ݣڸµ' + inttostr(CurDay) + '졭';
                lblStatus2.Caption := '' + inttostr(LettersCount) + 'ӣڸµ' + inttostr(CurLetter) + 'š';
                sbStatus.Panels[1].Text := DateToStr(CurDate);
                Update;
        end;

end;

procedure TfrmUpdata.OnStatusChange;
begin
       lblStatus1.Caption := XMLData.Status;
       Update;
end;

procedure TfrmUpdata.FormClose(Sender: TObject; var Action: TCloseAction);
begin
        Action := caFree;
end;

procedure TfrmUpdata.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := 0;

end;

end.
