unit xml;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  comctrls,StdCtrls,activeX, comObj, MSHTML,MSXML2_TLB;

type
   TOnProcess = procedure of object;

   TXMLData = class
       Roomlist_url,Roomlist_LocalFile:string;
       QList_Url,QList_LocalFile:string;
       Letter_Url,Letter_LocalFile:string;

       DaysCount:integer;
       CurDay:integer;
       CurDate:TDateTime;
       LettersCount:integer;
       CurLetter:integer;
       AbortFlag:boolean;

       OnUpdateLetter:TOnProcess;
       OnStatusChange:TOnProcess;

       function GetRoomList:boolean;
       function GetQList(DateFrom:TDateTime):boolean;overload;         //ȡָʱ䷶Χб
       constructor Create;
       function GetLastError:string;

       procedure UpdateRoomList;
       procedure UpdateLetters;
       procedure UpdateLettersAll(Datefrom:TDateTime;Index:integer; bForce:Boolean);

     private
       ErrorFlag:Integer;
       FElapseTime: TDateTime;
       FStatus:string;
       FFetchLetter:integer;

       function GetDatapro(Url,LocalFile:string):boolean;
       procedure ChkStr(var str:string);
       procedure ChkInt(var str:string);
       procedure DoUpdateLetter(LetterID:string);
       procedure DoGetLetter(LetterID:string);
     published
       property ElapseTime:TDateTime read FElapseTime;
       property Status:string read FStatus;
       property FetchLetter:integer read FFetchLetter;
   end;

const
        XMLERR_OK = 0;
        XMLERR_LOAD = 1;
        XMLERR_SAVEFILE = 2;
        XMLERR_FILENOTEXIST = 3;
        XMLERR_USERABORT = 4;

        UP_STYLE_TODAY = 0;
        UP_STYLE_DAY = 1;
        UP_STYLE_FROMDAY = 2;
        UP_STYLE_AUTO = 3;


implementation

{ TXMLData }

uses dm;

constructor TXMLData.Create;
begin
        Roomlist_url := 'http://www.delphibbs.com/delphibbs/listroom_.asp';
        Roomlist_LocalFile := ExtractFilePath(paramstr(0))+'tmpdata\roomlist.xml';
        QList_Url := 'http://www.delphibbs.com/delphibbs/chkl.asp';
        QList_LocalFile := ExtractFilePath(paramstr(0))+'tmpdata\qlist.xml';
        Letter_Url := 'http://www.delphibbs.com/delphibbs/getl.asp';
        Letter_LocalFile := ExtractFilePath(paramstr(0))+'tmpdata\q.xml';
end;

function TXMLData.GetDatapro(Url,LocalFile:string): boolean;
var
  xmlobj: IXMLDOMDocument;
begin
   Result := false;
   ErrorFlag := XMLERR_OK;
   xmlobj := CreateOLEObject('MSXML2.DOMDocument') as IXMLDOMDocument;
   xmlobj.async := true;
   xmlobj.load(Url);
   while xmlobj.readyState <> 4 do
   begin
        Application.ProcessMessages;
        if AbortFlag then
        begin
          ErrorFlag := XMLERR_USERABORT;      
          break;                                
        end;
   end; 
   if xmlobj.parseError.errorCode <> 0 then
   begin
        ErrorFlag := XMLERR_LOAD;
        Exit;
   end;
//   ShowMessage(IntToStr(xmlobj.parseError.errorCode));
   try
        xmlobj.Save(LocalFile)
   except
        ErrorFlag := XMLERR_SAVEFILE;
        Exit;
   end;

end;

function TXMLData.GetQList(DateFrom: TDateTime): boolean;
var
        NewQList_Url:string;
begin
        AbortFlag := false;
        //ָʱ𣬵ҹ
        NewQList_Url := QList_Url + '?datefrom=' + FormatDateTime('mm/dd/yyyy hh:mm:ss',DateFrom)
         + '&dateto=' + FormatDateTime('mm/dd/yyyy',trunc(DateFrom)) + ' 23:59:59';
//        ShowMessage(NewQList_Url);
        Result := GetDatapro(NewQList_Url,QList_LocalFile);
end;

function TXMLData.GetLastError: string;
begin
        case ErrorFlag of
          XMLERR_LOAD: Result := 'ȡXMLʱ';
          XMLERR_SAVEFILE: Result := 'ļʱ';
          XMLERR_FILENOTEXIST: Result := 'Ҳļ';
        else Result := 'ɡ';
        end;

end;

function TXMLData.GetRoomList: boolean;
begin
     Result := GetDatapro(Roomlist_url,Roomlist_LocalFile);
end;

procedure TXMLData.UpdateRoomList;
var
        xmlobj: IXMLDOMDocument;
        nodelst:array[0..3] of IXMLDOMNodeList;
        i,j:integer;
        ssql,XPath:string;
        RoomInfo:TRoomInfo;
begin
     if not FileExists(Roomlist_LocalFile) then
     begin
        ErrorFlag := XMLERR_FILENOTEXIST;
        exit;
     end;
        
   XPath := 'DFWML/ROOMS/ROOM';
   xmlobj := CreateOLEObject('MSXML2.DOMDocument') as IXMLDOMDocument;
   xmlobj.async := false;
   xmlobj.load(Roomlist_LocalFile);
   nodelst[0] := xmlobj.getElementsByTagName('name');
   nodelst[1] := xmlobj.getElementsByTagName('group');
   nodelst[2] := xmlobj.getElementsByTagName('master1');
   nodelst[3] := xmlobj.getElementsByTagName('master2');

   DM1.EmptyRooms;                 //վɵrooms
   for i := 0 to nodelst[0].length-1 do
   begin
        with RoomInfo do
        begin
                ID := nodelst[0].item[i].parentNode.attributes.getNamedItem('ID').text;
                Name := trim(nodelst[0].item[i].text);
                Master1 := trim(nodelst[2].item[i].text);
                Master2 := trim(nodelst[3].item[i].text);
                group := trim(nodelst[1].item[i].text);

                ChkStr(master1);
                ChkStr(master2);
                ChkStr(group);

        end;
        DM1.UpdateRoomList(RoomInfo);
   end;

end;

procedure TXMLData.DoUpdateLetter(LetterID:string);
var
        LetterInfo:TQuesInfo;

        xmlobj: IXMLDOMDocument;
        node: IXMLDOMNode;
        i,j:integer;
        XPath:string;
begin
        XPath := 'DFWML/L[@ID="' + LetterID + '"]';
        xmlobj := CreateOLEObject('MSXML2.DOMDocument') as IXMLDOMDocument;
        xmlobj.async := false;
        xmlobj.load(Letter_LocalFile);
        node := xmlobj.selectSingleNode(XPath);

        if VarIsEmpty(node) then
        begin
        exit;
        end;
        with LetterInfo do
        begin
                ID := LetterID;
                from := node.selectSingleNode('from').text;
                Content := node.selectSingleNode('content').text;
                datetime := node.selectSingleNode('datetime').text;
                RegdateTime := node.selectSingleNode('regdatetime').text;
                if RegdateTime = '' then RegdateTime := datetime;
                Parent := node.selectSingleNode('parent').text;

                if Parent = '0' then
                begin
                subject := node.selectSingleNode('subject').text;
                Points := node.selectSingleNode('points').text;
                read_n := node.selectSingleNode('read_n').text;
                ReplyTimes := node.selectSingleNode('reply_n').text;
                roomid := node.selectSingleNode('roomid').text;
                Status := node.selectSingleNode('status').text;
                end;

                ChkStr(from);
                ChkStr(content);
                ChkStr(RegdateTime);
                ChkStr(datetime);
                ChkInt(Parent);
                ChkStr(subject);
                ChkInt(Points);
                ChkInt(read_n);
                ChkInt(ReplyTimes);
                ChkInt(roomid);
                ChkInt(Status);
        end;


        DM1.UpdateLetter(LetterInfo);
end;

procedure TXMLData.ChkStr(var str: string);
begin
        if str = '' then str := ' ';

end;

procedure TXMLData.DoGetLetter(LetterID: string);
begin
        GetDatapro(Letter_Url + '?LID=' + LetterID,Letter_LocalFile)
end;

procedure TXMLData.UpdateLetters;
var
        xmlobj: IXMLDOMDocument;
        nodelst:array[0..0] of IXMLDOMNodeList;
        i,j:integer;
        ssql,LetterID:string;
begin
     if not FileExists(QList_LocalFile) then
     begin
        ErrorFlag := XMLERR_FILENOTEXIST;
        exit;
     end;

     AbortFlag := false;
   xmlobj := CreateOLEObject('MSXML2.DOMDocument') as IXMLDOMDocument;
   xmlobj.async := false;
   xmlobj.load(QList_LocalFile);
   nodelst[0] := xmlobj.getElementsByTagName('from');

   LettersCount := nodelst[0].length;
   for i := 0 to LettersCount - 1 do
   begin
        //ȡõбǰʱ併еģʱʱ
        LetterID := nodelst[0].item[LettersCount - i - 1].parentNode.attributes.getNamedItem('ID').text;

        CurLetter := i + 1;
        DoGetLetter(LetterID);
        DoUpdateLetter(LetterID);
        inc(FFetchLetter);
        Application.ProcessMessages;
        OnUpdateLetter;
        if AbortFlag then break;
   end;


end;

procedure TXMLData.ChkInt(var str: string);
begin
        if str = '' then str := '0';
end;

procedure TXMLData.UpdateLettersAll(Datefrom: TDateTime; Index: integer; bForce:Boolean);
var
        Days,i:integer;
        tmptime:TDateTime;
begin
        case Index of
          UP_STYLE_TODAY:
                begin
                  Datefrom := trunc(now);
                  Days := 1;
                end;
          UP_STYLE_DAY:
                begin
                  Datefrom := trunc(Datefrom);
                  Days := 1;
                end;
          UP_STYLE_FROMDAY:
                begin
                  Days := trunc(now) - trunc(datefrom) + 1;
                end;
          UP_STYLE_AUTO:
                begin
                  Datefrom := 0;       
                end;
        else ;
        end;

        FStatus := 'ڶλ¼';
        OnStatusChange;
        if bForce = false then                   //ʹǿƸ¹
          Datefrom := DM1.GetDayLastTime(Datefrom);       //ȡָһӵʱ
        if Index = UP_STYLE_AUTO then Days := trunc(now) - trunc(datefrom) + 1;

        tmptime := now;
        ErrorFlag := XMLERR_OK;
        AbortFlag := false;
        DaysCount := Days;
        FFetchLetter := 0;
        for i := 0 to Days - 1 do
        begin
                CurDay := i + 1;
                CurDate := Datefrom;

                FStatus := 'ڻȡб';
                OnStatusChange;
                GetQList(Datefrom);
                if ErrorFlag <> XMLERR_OK then
                begin
                  break;      
                end;

                FStatus := 'ڸӡ';
                OnStatusChange;
                UpdateLetters;
                
                Datefrom := trunc(Datefrom) + 1;
                if AbortFlag then
                begin
                  ErrorFlag := XMLERR_USERABORT;
                  break;
                end;
        end;
        FElapseTime := now - tmptime;
        FStatus := 'ɡ';
        OnStatusChange;
end;


end.
